#include <Nextion.h>
#include <DHT.h>
#include <ESP8266WiFi.h>

#define DHTTYPE22 DHT22
#define DHT22_PIN 4
DHT dht22(DHT22_PIN, DHTTYPE22); // Inicializa SONDA DHT-22 -----

unsigned int tiempoActual = millis();
unsigned int previousMillis = 0;
int intervalo   = 4000;
uint32_t  prueba = 0;
int sp = 24;
float hum22;
float temp22;
 
NexNumber temperatura = NexNumber(0, 1, "n0");
NexNumber humedad = NexNumber(0, 2, "n1");
NexNumber n2 = NexNumber(0, 3, "n2");
NexNumber setpoint = NexNumber(0, 5, "n4");
NexButton up = NexButton(0, 9, "b0");
NexButton down = NexButton(0, 10, "b1");
NexPage page0 = NexPage(0, 0, "page0");

char buffer[100] = {0};

NexTouch *nex_listen_list[] =
{
  &up,
  &down,
  NULL
};

void upPushCallback(void *ptr)
{
  sp++;
  setpoint.setValue(sp);
}

void downPushCallback(void *ptr)
{
  sp--;
  setpoint.setValue(sp);
}



void setup() {
  // put your setup code here, to run once:
  //Serial.begin(9600);
  dht22.begin();
  //WiFi.begin(ssid, password);
  nexInit();
  TempHum();
  setpoint.setValue(sp);
  up.attachPush(upPushCallback, &up);
  down.attachPush(downPushCallback, &down);
}

void loop() {
  nexLoop(nex_listen_list);
  TempHum();
  /*
  if (tiempoActual - previousMillis > intervalo) {
    TempHum();
    previousMillis = tiempoActual;
  }
  */
}

void TempHum()
{
  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  hum22 = dht22.readHumidity();
  // Read temperature as Celsius (the default)
  temp22 = dht22.readTemperature();

  // Check if any reads failed and exit early (to try again).
  /*if (isnan(hum11) || isnan(temp11) || isnan(hum22) || isnan(temp22) ) {
    Serial.println("Failed to read from DHT sensor!");
    return;
    }*/
  // Compute heat index in Celsius (isFahreheit = false)
  float hic22 = dht22.computeHeatIndex(temp22, hum22, false);
  int temp = temp22;
  int hum = hum22;
  temperatura.setValue(temp);
  humedad.setValue(hum);
}
